=== debian/changelog ===
luanti (5.13.0+dfsg-0.1~mx25+1) mx; urgency=medium

  * New upstream release.
  * Remove d/patches; applied in the new releases.
  * Add libsdl2-dev to BDs to fix FTBFS.
  * Disable all tests on armhf as they fail.

 -- Steven Pusser <stevep@mxlinux.org>  Mon, 15 Sep 2025 14:27:57 -0700
