## luanti 5.14.0+dfsg

=== debian/changelog ===
luanti (5.14.0+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Remove /var/(lib|log)/private/luanti on purge. (Closes: #1122677)
  * Don't log to file by default, use journald. (Closes: #1125461)
  * As we are logging to journald, logrotate is no longer needed.

 -- Tobias Frost <tobi@debian.org>  Sun, 15 Feb 2026 12:57:32 +0100

luanti (5.14.0+dfsg-2) unstable; urgency=medium

  * Team upload
  * Enable loong64

 -- Bastian Germann <bage@debian.org>  Wed, 21 Jan 2026 23:16:41 +0100

luanti (5.14.0+dfsg-1) unstable; urgency=medium

  * New upstream version 5.14.0+dfsg
    (Closes: #1102042, #1119258)
  * Remove i386 from builds
    * Core unit test is failing but unable to fix so far
  * Remove transitional packages
  * Drop patches applied upstream
  * Refresh test skip patch
  * Remove minetest/minetestserver migration aliases
  * Add patch to fix AppStream metadata

 -- Travis Wrightsman <travis@wrightsman.org>  Sun, 05 Oct 2025 21:19:35 +0200
