=== debian/control ===
Source: luanti
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Travis Wrightsman <travis@wrightsman.org>,
 Martin Quinson <mquinson@debian.org>,
 Markus Koschany <apo@debian.org>,
 Dominik George <natureshadow@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 gettext,
 libcurl4-openssl-dev,
 libfreetype-dev,
 libgl-dev,
 libgmp-dev,
 libjpeg-dev,
 libjsoncpp-dev,
 libleveldb-dev,
 libluajit-5.1-dev,
 libogg-dev,
 libopenal-dev,
 libpng-dev,
 libpq-dev,
 libsdl2-dev,
 libspatialindex-dev,
 libsqlite3-dev,
 libvorbis-dev,
 libxi-dev,
 pkgconf,
 zlib1g-dev,
 libzstd-dev,
 prometheus-cpp-dev
Standards-Version: 4.7.2
Homepage: https://www.luanti.org
Vcs-Git: https://salsa.debian.org/games-team/luanti.git
Vcs-Browser: https://salsa.debian.org/games-team/luanti
Rules-Requires-Root: no

Package: luanti
Architecture: amd64 arm64 armhf loong64 ppc64el riscv64 s390x
Depends:
 luanti-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 luanti-game-minetest
Suggests:
 luanti-server,
 minetestmapper
Description: Multiplayer infinite-world block sandbox
 Luanti is a Minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.

Package: luanti-server
Architecture: amd64 arm64 armhf loong64 ppc64el riscv64 s390x
Depends:
 luanti-data (= ${source:Version}),
 luanti-game-minetest,
 ${misc:Depends},
 ${shlibs:Depends}
Pre-Depends:
 ${misc:Pre-Depends}
Description: Multiplayer infinite-world block sandbox (server)
 Luanti is a minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 This is the Luanti server package.

Package: luanti-data
Architecture: all
Multi-Arch: foreign
Depends:
 fonts-croscore,
 fonts-droid-fallback,
 ${misc:Depends}
Description: Multiplayer infinite-world block sandbox (data files)
 Luanti is a Minecraft-inspired game written from scratch and licensed
 under the LGPL (version 2.1 or later). It supports both survival and creative
 modes along with multiplayer support, dynamic lighting, and an "infinite" map
 generator.
 .
 These are the files used by both client and server packages, such as
 the textures and other graphical files and the standard mods.
